#ifndef _ABOUT_BOX_H_
#define _ABOUT_BOX_H_

#include <Window.h>
#include <ScrollView.h>
#include <ListView.h>
#include <Box.h>
#include <String.h>
#include <StringView.h>
#include "GenList.h"

class LinkStringView : public BStringView
{
	public:
		LinkStringView( BRect frame, const char* name, const char* text );
		void MouseDown(BPoint point);
		void Draw(BRect updateRect);
		void SetURLMode( BString url, bool web );
		
	private:
		int urlMode;
		BString url;
};

class AboutView : public BView
{
	friend class AboutWindow;

	public:
		AboutView( BRect rect );

	private:
		BButton* SKButton;
		BButton* OKButton;
		BStringView* bySV;
		BStringView* verSV;
		BStringView* majorSV;
};


class AboutWindow : public BWindow
{
	public:
		AboutWindow( BRect frame );
		~AboutWindow();

		virtual void MessageReceived(BMessage* message);
		virtual void DispatchMessage( BMessage* msg, BHandler* handler );	
		virtual	bool QuitRequested();

	private:

		AboutView *genView;
};

#endif
