#include <Alert.h>
#include <string.h>
#include <stdio.h>
#include "BeAIM.h"
#include "constants.h"
#include "Globals.h"
#include "AIMNetThread.h"
#include "TrayIcon.h"
#include "Say.h"

#include "InfoWindow.h"

//---------------------------------------------------------------------

main( int argc, void** argv )
{	
	strcpy( AppFileName, (char*)argv[0] );
	skMode = false;

	BeAIMApplication myApplication;
	myApplication.Run();
	return(0);
}

//---------------------------------------------------------------------

BeAIMApplication::BeAIMApplication()
		  		  : BApplication(APP_SIGNATURE)
{
	// Do startup stuff
	DoBeAIMStartupStuff();

	// create the signon window and show it
	windows->OpenSignOnWindow();

	/*
	user->SetUser( "MegaPiffle" );
	BRect rect(0,0,330,286); 
	rect.OffsetBy( 100, 100 );
	InfoWindow* ret = new InfoWindow( rect, "MtDew42" );
	ret->Show();
	
	snooze( 1000000 );	
	BMessage* normal = new BMessage(BEAIM_UPDATE_INFO);
	normal->AddString( "userid", "MtDEW42" );
	normal->AddString( "profile", "<html><body bgcolor=\"#66FF66\">This <b>is</b> a <i>profile@profile.com</i></body></html>" );
	normal->AddInt32( "idletime", 1023 );
	normal->AddString( "userclass", "Internet" );
	normal->AddBool( "away", false );
	ret->PostMessage( normal );
	
	snooze( 1000000 );	
	normal = new BMessage(BEAIM_UPDATE_AWAY_INFO);
	normal->AddString( "userid", "MtDEW42" ); 
	normal->AddString( "away_message", "<html><body bgcolor=\"#FF0000\"><font color=\"#FFFFFF\">Hello, %n, This <b>is</b> an www.away.com message.<br>time: %t<br>date: %d</font></body></html>" );
	ret->PostMessage( normal );
	*/

	// Fake Incoming Message...
	/*
	user->SetUser( "MtDew42" );
	user->ReadUserFile();
	windows->OpenBuddyList();
	BMessage* msgRecv = new BMessage(BEAIM_INCOMING_IM);
	msgRecv->AddString( "userid", "BigZaphod" );
	msgRecv->AddInt32( "wtype", 1 );
	msgRecv->AddInt32( "idletime", 0 );
	//msgRecv.AddString( "message", "<font color=\"#BB00BB\" size=5>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!<br>Test!</font>" );
	//msgRecv.AddString( "message", "Embedding a <a href=\"http://www.yahoo.com\">Link</a><a href=\"http://www.amazon.com\"> in the text</a>... <a href=\"http://www.puddle.org\">oh yeah!</a>" );
	//msgRecv.AddString( "message", "This<b>is<i>a</i>test</b>of the most importance!" );
	msgRecv->AddString( "message", "Hey, have you taken a look at <a href=\"http://www.bebits.com/\">BeBits</a> lately? It's <i>really</i> cool!" );
	msgRecv->AddInt32( "warninglevel", 25 );
	windows->ForwardIncomingMessage( msgRecv );
	*/

	//Fake Oncoming Buddy...
	/*
	user->SetUser( "MtDew42" );
	user->ReadUserFile();
	windows->OpenBuddyList();
	BMessage* msgRecv = new BMessage(BEAIM_ONCOMING_BUDDY);
	msgRecv->AddString( "userid", "BigZaphod" );
	msgRecv->AddInt32( "idletime", 0 );
	msgRecv->AddInt32( "warninglevel", 30 );
	windows->SendBuddyListMessage( msgRecv );
	//snooze( 2000000 );
	//Say( "hi" );
	
	//msgRecv = new BMessage(BEAIM_OFFGOING_BUDDY);
	//msgRecv.AddString( "userid", "BigZaphod" );
	//msgRecv.AddInt32( "proto", int32(AIM_PROTOCOL) );
	//windows->SendBuddyListMessage( &msgRecv );
	*/
}

//---------------------------------------------------------------------

BeAIMApplication::~BeAIMApplication() {

}

//---------------------------------------------------------------------

bool BeAIMApplication::QuitRequested() {

	DoBeAIMShutdownStuff();
	return true;
}

//---------------------------------------------------------------------

// Central message "switchboard" of BeAIM
void BeAIMApplication::MessageReceived( BMessage* message )
{
	message->AddInt32( "proto", int32(AIM_PROTOCOL) );

	switch(message->what)
	{
		// forward these to the login window
		case BEAIM_SET_LOGIN_STEP_COUNT:
		case BEAIM_LOGIN_STEP:
		case BEAIM_LOGIN_FAILURE:
			windows->SendSignOnMessage( message );
			break;

		case BEAIM_ONCOMING_BUDDY:
			windows->ForwardIncomingMessage( message );
		case BEAIM_ADD_PERSON:
		case BEAIM_OFFGOING_BUDDY:
		case BEAIM_LOAD_AWAY_MENU:
			windows->SendBuddyListMessage( message );
			break;

		case BEAIM_SEND_MESSAGE:
			sounds->PlaySound( WS_MSGSEND );
		case BEAIM_WARN_SOMEONE:
		case BEAIM_SET_USER_BLOCKINESS:
		case BEAIM_CANCEL_SIGN_ON:
		case BEAIM_GET_PERSON_INFO:
		case BEAIM_GET_AWAY_INFO:
		case BEAIM_SIGN_ON:
		case BEAIM_PEOPLELIST_COMMIT:
		case BEAIM_SEARCH_BY_EMAIL:
		case BEAIM_NOW_IDLE:
		case BEAIM_NOW_ACTIVE:
		case BEAIM_GOING_AWAY:
		case BEAIM_SEND_IDLE_PULSE:
			net->PostMessage( message );
			break;

		case BEAIM_LOGOUT:
			Logout();
			break;
			
		case BEAIM_SEND_ARBITRARY_DATA:
			windows->MakeDataSenderWindow();
			break;

		case BEAIM_OPEN_IM_WINDOW:
		case BEAIM_OPEN_USER_WINDOW:
			windows->OpenUserWindow( message );
			break;

		case BEAIM_IM_WINDOW_OPENED:
			windows->UserWindowOpened( message );
			break;

		case BEAIM_IM_WINDOW_CLOSED:
			windows->UserWindowClosed( message );
			break;

		case BEAIM_TOGGLE_HIDDEN:
			windows->ToggleHidden(false);
			break;

		case BEAIM_SIGN_ON_SUCCESSFUL:
			user->SetLoggedIn( true );
			windows->OpenBuddyList();
			windows->CloseSignOnWindow();
			break;
			
		case BEAIM_UPDATE_INFO:
		case BEAIM_UPDATE_AWAY_INFO:
		case BEAIM_INCOMING_IM:
			windows->ForwardIncomingMessage( message );
			break;

		case BEAIM_EMAIL_SEARCH_RESULTS:
			windows->ForwardEmailSearchResults( message );
			break;

		case BEAIM_NEXT_CHAT_WINDOW:
		case BEAIM_PREV_CHAT_WINDOW:
			windows->SwitchUserWindow( message );
			break;

		case BEAIM_RELOAD_PREF_SETTINGS:
			DoGlobalPrefs();
			break;
			
		case BEAIM_TOGGLE_DESKBAR_ICON:
			DoDeskbarIcon( message->FindBool("enabled") );
			break;
			
		case BEAIM_OPEN_SINGLE_WINDOW:
			if( message->HasInt32("posnum") )
				windows->OpenSingleWindow( message, message->FindInt32("posnum") );
			else
				windows->OpenSingleWindow( message );
			break;
			
		case BEAIM_SINGLE_WINDOW_CLOSED:
			windows->SingleWindowClosed( message );
			break;

		case BEAIM_DISCONNECTED:
			if( !(message->HasBool("done")) )
				GotDisconnected();
			break;
			
		case BEAIM_PERHAPS_IMPORT:
			PerhapsImport();
			break;

		case BEAIM_SET_MY_SCREEN_NAME:
			user->SetUser( message->FindString("new_userid") );
			break;
			
		case BEAIM_DISPLAY_MESSAGE:
			windows->DisplayMessage( message );
			break;

		case BEAIM_SKMODE_CHANGED:
		case BEAIM_GOT_WARNED:
			windows->BroadcastMessage( message );
			break;

		case BEAIM_JUMP_TO_BUDDYLIST:
			windows->ToggleHidden(true);
			break;

		default:
			BApplication::MessageReceived( message );
	}
}

//---------------------------------------------------------------------

void BeAIMApplication::DoBeAIMStartupStuff() {

	deskbarIconInstalled = false;
	
	// Create the necessary global objects
	net = new AIMNetThread;
	windows = new WindowManager;
	list = new PeopleList;
	sounds = new classSoundMaster;
	user = new UserManager;
	skMode = false;
}

//---------------------------------------------------------------------

void BeAIMApplication::DoBeAIMShutdownStuff() {

	// Save the user settings if we need to
	if( user->LoggedIn() )
		user->WriteUserFile();

	// remove the tray icon
	if( deskbarIconInstalled )
		DoDeskbarIcon( false );

	// net will take care of deleting itself
	if( net )
		net->Logout();
	net = 0;
	user->WriteUserFile();
	delete user;
	user = 0;
	delete list;
	list = 0;
	windows->CloseDaWindows();
	delete windows;
	windows = 0;
	delete sounds;
	sounds = 0;
}

//---------------------------------------------------------------------

void BeAIMApplication::DoDeskbarIcon( bool install ) {

	if( install )
		TrayIcon::AddTrayIcon();	
	else
		TrayIcon::RemoveTrayIcon();	
	
	deskbarIconInstalled = install;
}

//---------------------------------------------------------------------

void BeAIMApplication::AboutRequested() {

	BMessage* msg = new BMessage(BEAIM_OPEN_SINGLE_WINDOW);
	msg->AddInt32( "wtype", SW_ABOUT_BOX );
	windows->OpenSingleWindow(msg);
}

//---------------------------------------------------------------------

void BeAIMApplication::PerhapsImport() {

	BAlert* alert = new BAlert("title", "Right now, you don't have anybody in your buddylist. Do you have a different buddylist (from AIM for Windows, or an older version of BeAIM) that you would like to import?", "No", "Yes", NULL, B_WIDTH_AS_USUAL, B_EVEN_SPACING, B_WARNING_ALERT);
	alert->SetShortcut( 0, B_ESCAPE );
	if( alert->Go() ) {
		BMessage* msg = new BMessage(BEAIM_OPEN_SINGLE_WINDOW);
		msg->AddInt32("wtype", SW_BUDDYLIST_IMPORTER);
		windows->OpenSingleWindow(msg);
		windows->SendBuddyListMessage( new BMessage(BEAIM_SWITCH_TO_BLIST_TAB) );
	}
}

//---------------------------------------------------------------------

void BeAIMApplication::DoGlobalPrefs() {

	// do sound prefs
	bool soundEnabled = user->ReadBool("PlaySounds", true);
	if( sounds->IsEnabled() != soundEnabled )
		sounds->SetEnabled( soundEnabled );

	// do deskbar icon prefs
	bool deskbarEnabled = user->ReadBool("UseDeskbarIcon", true);
	if( deskbarEnabled != deskbarIconInstalled ) {
		DoDeskbarIcon( deskbarEnabled );	
	}
}

//---------------------------------------------------------------------

void BeAIMApplication::GotDisconnected() {

	BMessage* disMessage;

	if( user->LoggedIn() ) {
		user->WriteUserFile();
		user->SetLoggedIn(false);
		windows->CloseDaWindows();
		disMessage = new BMessage(B_QUIT_REQUESTED);
		disMessage->AddBool("dontkill", true);
		windows->SendBuddyListMessage( disMessage );
		windows->OpenSignOnWindow();
		Say( "You have been disconnected from the AIM server." );
	}
}

//---------------------------------------------------------------------

void BeAIMApplication::Logout() {

	BMessage* disMessage;
	windows->CloseDaWindows();
	user->WriteUserFile();
	disMessage = new BMessage(B_QUIT_REQUESTED);
	disMessage->AddBool("dontkill", true);
	windows->SendBuddyListMessage( disMessage );
	windows->OpenSignOnWindow();
	user->SetLoggedIn(false);
	disMessage = new BMessage( BEAIM_LOGOUT );
	net->PostMessage( disMessage );
}

//---------------------------------------------------------------------
