#ifndef _IMPORTER_H_
#define _IMPORTER_H_

#include <Window.h>
#include <ScrollView.h>
#include <ListView.h>
#include <Box.h>
#include <TextControl.h>
#include <FilePanel.h>
#include <String.h>
#include <CheckBox.h>
#include "GenList.h"
#include "AimBuddyConv.h"



class ImporterConfirmView : public BView
{
	friend class ImporterConfirmWindow;

	public:
		ImporterConfirmView( BRect rect );
		
	private:
		BScrollView* scroll;
		BTextView* textview;
		BCheckBox* replaceBox;
};


class ImporterConfirmWindow : public BWindow
{
	public:
		ImporterConfirmWindow( BRect frame, BWindow* owner, entry_ref, int );
		~ImporterConfirmWindow();

		virtual void MessageReceived(BMessage* message);
		virtual void DispatchMessage( BMessage* msg, BHandler* handler );	
		virtual	bool QuitRequested();

	private:
	
		void FillList();
		void Save();

		BWindow* owner;
		group* thelist;
		int type;
		entry_ref ref;
		ImporterConfirmView *genView;
};

//-------------------------------------------------------------------------

class ImporterView : public BView
{
	friend class ImporterWindow;

	public:
		ImporterView( BRect rect );
	
	private:
		BButton* closeButton;		
};


class ImporterWindow : public BWindow
{
	public:
		ImporterWindow( BRect frame );
		~ImporterWindow();

		virtual void MessageReceived(BMessage* message);
		virtual void Show();
		virtual void DispatchMessage( BMessage* msg, BHandler* handler );	
		virtual	bool QuitRequested();

	private:
	
		void Import1( BMessage* msg );
		void Import2( BMessage* msg );
		void Import3( BMessage* msg );
		void Import4( BMessage* msg );
		void Info1();
		void Info2();
		void Info3();
		void Info4();
		
		bool GetSettingsRef( entry_ref& ref );
		void SetupConfView( entry_ref, int );
		
		ImporterConfirmWindow* confWin;
		ImporterView *genView;
		BFilePanel* panel1;
		BFilePanel* panel2;
		BFilePanel* panel3;
		BFilePanel* panel4;
};


#endif
