#ifndef _PREFERENCES_H_
#define _PREFERENCES_H_

#include <Window.h>
#include <View.h>
#include <CheckBox.h>
#include <Button.h>
#include <Slider.h>
#include "ColorView.h"

const uint32 PREFS_SAVE = 'PrSv';
const uint32 PREFS_CANCEL = 'PrCl';

//-------------------------------------------------------------------------------------------------------

class GSlider : public BSlider {

	public:
		GSlider( BRect frame, int32 min, int32 max );
		virtual char* UpdateText( void ) const;
		
	private:
		char upText[200];
};

//-------------------------------------------------------------------------------------------------------

class GenPrefView : public BView 
{
	public:
		GenPrefView(BRect frame, bool globalOnly = false );
		void Save();

	private:
		BCheckBox* BuddyListAllWorkspaces;
		BCheckBox* PlaySounds;
		BCheckBox* UseDeskbar;
		BCheckBox* DoIdleTime;
		BCheckBox* EnterInsertsNewline;
		BCheckBox* TabIsTab;
		bool globalOnly;
};


//-------------------------------------------------------------------------------------------------------

class ConnectionPrefView : public BView 
{
	public:
		ConnectionPrefView(BRect frame, bool globalOnly = false );
		void Save();

	private:
		BTextControl* conHost;
		BTextControl* conPort;
		bool globalOnly;		
};


//-------------------------------------------------------------------------------------------------------

class ChatWindowPrefView : public BView 
{
	public:
		ChatWindowPrefView(BRect frame, bool globalOnly = false );
		void OpenColorPicker( BMessage* msg );
		void SetNewColor( BMessage* msg );
		void Save();

	private:
		BCheckBox* ChatWindowAllWorkspaces;
		BCheckBox* ChatWindowPopup;
		BCheckBox* ChatFontColorSizes;
		BCheckBox* ChatShowLinks;
		BCheckBox* ChatPrefixNewMessages;
		GSlider* magSlider;
		ColorView* bgColor;
		ColorView* fontColor;
		ColorView* fromYouColor;
		ColorView* toYouColor;
		bool globalOnly;
};

//-------------------------------------------------------------------------------------------------------

class AwayPrefView : public BView 
{
	public:
		AwayPrefView(BRect frame, bool globalOnly = false );
		void Save();

	private:
		//BCheckBox* BuddyListAllWorkspaces;
		bool globalOnly;
};


//-------------------------------------------------------------------------------------------------------

class PrefsWindow : public BWindow 
{
	public:
		PrefsWindow( BRect frame, bool globalOnly = false ); 
		virtual	bool QuitRequested();
		virtual void MessageReceived( BMessage *message );
		virtual void DispatchMessage( BMessage* msg, BHandler* handler );
		
	private:
		GenPrefView* genPrefs;
		ConnectionPrefView* conPrefs;
		ChatWindowPrefView* chatPrefs;
		AwayPrefView* awayPrefs;
};

#endif